/*
 * clientPost.c: A very, very primitive HTTP client for sensor
 * 
 * To run, prepare config-cp.txt and try: 
 *      ./clientPost
 *
 * Sends one HTTP request to the specified HTTP server.
 * Get the HTTP response.
 */


#include <stdio.h>
#include <pthread.h>
#include <assert.h>
#include <stdlib.h>
#include <semaphore.h>
#include <sys/time.h>
#include <time.h>
#include "stems.h"

void clientSend(int fd, char *filename, char *body)
{
  char buf[MAXLINE];
  char hostname[MAXLINE];

  Gethostname(hostname, MAXLINE);

  /* Form and send the HTTP request */
  sprintf(buf, "POST %s HTTP/1.1\n", filename);
  sprintf(buf, "%sHost: %s\n", buf, hostname);
  sprintf(buf, "%sContent-Type: text/plain; charset=utf-8\n", buf);
  sprintf(buf, "%sContent-Length: %ld\n\r\n", buf, strlen(body));
  sprintf(buf, "%s%s\n", buf, body);
  Rio_writen(fd, buf, strlen(buf));
}
  
/*
 * Read the HTTP response and print it out
 */
void clientPrint(int fd)
{
  rio_t rio;
  char buf[MAXBUF];  
  int length = 0;
  int n;
  
  Rio_readinitb(&rio, fd);

  /* Read and display the HTTP Header */
  n = Rio_readlineb(&rio, buf, MAXBUF);
  while (strcmp(buf, "\r\n") && (n > 0)) {
    /* If you want to look for certain HTTP tags... */
    if (sscanf(buf, "Content-Length: %d ", &length) == 1)
    printf("Length = %d\n", length);
    printf("Header: %s", buf);
    n = Rio_readlineb(&rio, buf, MAXBUF);
  }

  /* Read and display the HTTP Body */
  n = Rio_readlineb(&rio, buf, MAXBUF);
  while (n > 0) {
    printf("%s", buf);
    n = Rio_readlineb(&rio, buf, MAXBUF);
  }
}

/* currently, there is no loop. I will add loop later */
void userTask(char *myname, char *hostname, int port, char *filename, float timer, float value)
{
  int clientfd;
  char msg[MAXLINE];
  char c[MAXLINE];
  char *ptr;
  char *ch;
  char *arg;
  int count;
  float val;
	
	while(1){
		printf(">>");
		scanf(" %[^\n]",c);
		ch = strtok(c," ");
		ptr = ch;
		ch = strtok(NULL, " ");     
		arg = ch;
		if (strcmp(ptr,"help")== 0){
			printf("this is help\n");
			printf("help : list available cmommands.\n");
			printf("name : print current sensor name\n");
			printf("name <sensor>:change sensor name to <sensor> \n");
			printf("value : print current value of sensor\n");
			printf("value <n>: set sonsor value to <n>\n");
			printf("send: send (current sensor name, time, value) to server)\n");
			printf("random <n>: send (name, time, random value) to server <n> times.");
			printf("quit: quit the program\n");
			}

		
		else if (strcmp(ptr,"name")== 0){ 
			if (arg == NULL)
				printf("current sensor is '%s'\n",myname);
			else{
				strcpy(myname, arg);
				printf("sensor name is changed to '%s'\n",myname);
				}
			}
			
		else if (strcmp(ptr,"value")== 0){ 
			if (arg == NULL){
				printf("Current value of sensor is '%f'\n",value);
				}
			else{
				value = atof(arg);
				printf("Sensor value is changed to '%f'\n",value);
				}
			}
		
		else if (strcmp(ptr,"send") == 0){
			timer = timer + 1.0;
			printf("this is send\n");
			sprintf(msg, "name=%s&time=%f&value=%f", myname, timer, value);
			printf("sending %s\n",msg);
			clientfd = Open_clientfd(hostname, port);
			clientSend(clientfd, filename, msg);
			clientPrint(clientfd);
			Close(clientfd);
			}
		
		
		else if (strcmp(ptr,"random") == 0) {
			count = atoi(arg);
			printf("count is %d\n",count);
			for (int i = 0; i<count;i++){
				timer = timer + 1.0;
				val = ((rand() % (20))+20);
				//printf("val is %f\n",val);
				value = val;
				sprintf(msg, "name=%s&time=%f&value=%f", myname, timer, value);
				printf("sending %s\n",msg);
				clientfd = Open_clientfd(hostname, port);
				clientSend(clientfd, filename, msg);
				//clientPrint(clientfd);
				Close(clientfd);
				sleep(1);
				}
		}
		
		else if (strcmp(ptr,"quit") == 0) break;
		else {
			printf("not command \n");
			continue;
			}	
	}
}

void getargs_cp(char *myname, char *hostname, int *port, char *filename, float *timer, float *value)
{
  FILE *fp;

  fp = fopen("config-cp.txt", "r");
  if (fp == NULL)
    unix_error("config-cp.txt file does not open.");
	
  fscanf(fp, "%s", myname);
  fscanf(fp, "%s", hostname);
  fscanf(fp, "%d", port);
  fscanf(fp, "%s", filename);
  fscanf(fp, "%f", timer);
  fscanf(fp, "%f", value);
  fclose(fp);
}

int main(void)
{
  char myname[MAXLINE], hostname[MAXLINE], filename[MAXLINE];
  int port;
  float timer, value;

  getargs_cp(myname, hostname, &port, filename, &timer, &value);
  userTask(myname, hostname, port, filename, timer, value);

  return(0);
}
