#include "stems.h"
#include "/usr/include/mysql/mysql.h"
#include "request.h"
#include <sys/time.h>
#include <assert.h>
#include <unistd.h>


#define DB_HOST "127.0.0.1"
#define DB_USER "song"
#define DB_PASS "song"
#define DB_NAME "open"


void htmlReturn(void)
{
  char content[MAXLINE];
  char *ptr;
  char *buf;
  char *method;
  char *length;
  char *rest;
  char temp[3][50];
  char temp_res[MAXLINE];
  int restlen = 0;
  rio_t rio;

  method = getenv("REQUEST_METHOD");
  if(strcasecmp(method, "GET")==0){
	  buf = getenv("QUERY_STRING");
  }
  else if(strcasecmp(method, "POST")==0){
	  length = getenv("CONTENT_LENGTH");
	  rest = getenv("REST_CONTENTS");
	  if(rest != NULL){
		  restlen = strlen(rest);
	  }
	  if(atoi(length) < restlen){
		  read(STDIN_FILENO, buf, restlen);
	  }
  }

  printf("\n");

  ptr = strsep(&buf, "=");
  int tn = 0;
  while (ptr != NULL){
	  ptr = strsep(&buf, "&");
	  strcpy(temp[tn], ptr);
	  ptr = strsep(&buf, "=");
	  tn++;
  }
	
  char query_str[255];
  
  MYSQL *conn = mysql_init(NULL);
  if(conn == NULL){
	  fprintf(stderr, "%s\n", mysql_error(conn));
	  exit(1);
  }
	
  mysql_real_connect(conn, DB_HOST, DB_USER, DB_PASS, DB_NAME, 0, NULL, 0);
	
  int num_fields;
  MYSQL_RES *result = mysql_store_result(conn);
  MYSQL_ROW row;
	
  if (strcmp(temp[0],"LIST") == 0){
	  sprintf(query_str, "select name from sensorList");
	  mysql_query(conn, query_str);
	  result = mysql_store_result(conn);
	  num_fields = mysql_num_fields(result);
	  printf("[name]	\n");
	  while(row = mysql_fetch_row(result)){
		  for(int i = 0; i < num_fields; i++){
			  printf("%s", row[i]);
		  }
		  printf("\n");
	  }
	  printf("\n");
  }
  else if (strcmp(temp[0],"INFO") == 0){
	  sprintf(query_str, "select name, count, average from sensorList where name='%s'", temp[1]);
	  mysql_query(conn, query_str);
	  result = mysql_store_result(conn);
	  num_fields = mysql_num_fields(result);
	  printf("[name]	[count]	[average]\n");
	  while(row = mysql_fetch_row(result)){
		  for(int i = 0; i < num_fields; i++){
			  printf("%s	", row[i]);
		  }
		  printf("\n");
	  }
	  printf("\n");
  }
  else if (strcmp(temp[0],"GET") == 0){
	  int count;
	  int id;
	  sprintf(query_str, "select id, count from sensorList where name='%s'", temp[1]);
	  mysql_query(conn, query_str);
	  result = mysql_store_result(conn);
	  num_fields = mysql_num_fields(result);
	  row = mysql_fetch_row(result);
	  id = atoi(row[0]);
	  count = atoi(row[1]);
	  
	  
	  if(strcmp(temp[2], "") == 0){
		  sprintf(query_str, "select time, value from sensor%d where idx=%d", id, count);
	  }
	  else {
		  int n = atoi(temp[2]);
		  sprintf(query_str, "select time, value from sensor%d where idx>%d", id, count-n);
	  }
	  mysql_query(conn, query_str);
	  result = mysql_store_result(conn);
	  num_fields = mysql_num_fields(result);
	  printf("[time]	[value]	\n");
	  while(row = mysql_fetch_row(result)){
		  for(int i = 0; i < num_fields; i++){
			  printf("%s	", row[i]);
		  }
		  printf("\n");
	  }
	  printf("\n");
  }
	
  mysql_free_result(result);
  mysql_close(conn);
  
  fflush(stdout);
}

void textReturn(void)
{
  char content[MAXLINE];
  char *buf;
  char *ptr;

  buf = getenv("QUERY_STRING");
  sprintf(content,"%sEnv : %s\n", content, buf);
  ptr = strsep(&buf, "&");
  while (ptr != NULL){
    sprintf(content, "%s%s\n", content, ptr);
    ptr = strsep(&buf, "&");
  }
  
  /* Generate the HTTP response */
  printf("Content-Length: %d\n", strlen(content));
  printf("Content-Type: text/plain\r\n\r\n");
  printf("%s", content);
  fflush(stdout);
}

int main(void)
{
  htmlReturn();
  //textReturn();
  return(0);
}
